;=========================================================================
; DEBUG
; file : debug.inc
; 2003/10/25
; Copyright (C) 2003 Jun Mizutani <mizutani.jun;nifty.ne.jp>
;=========================================================================
%ifndef __DEBUG_INC
%define __DEBUG_INC

%ifndef __STDIO_INC
%include "stdio.inc"
%endif

%define quote   '

; 쥸ͤɽޥ
; ٤ƤΥ쥸˲ɽǽ
; ե饰쥸Ѳ
; ٥Ȥ998:999:ȤäƤ뤳Ȥա
;   ex. PRINTREG 'eax'

%macro  PRINTREG   1
        pusha
        push    eax
        mov     eax, %%L0
        call    OutAsciiZ
        pop      eax
        push     eax
        push    ecx
        mov     eax, %1
        mov     ecx, 12
        call    PrintRight
        call    PrintRightU
        mov     al, ':'
        call    OutChar
        pop     ecx
        pop     eax
        push    eax
        push    edx
        mov     eax, %1
        call    PrintHex8
        pop     edx
        mov     al, ' '
        call    OutChar
        pop     eax
        mov     eax, %1
        call    OutChar4
        call    NewLine
        popa
        jmp     short %%L1
%%L0:  db       quote %1 quote, 0
%%L1:
%endmacro

; 쥸ͤƬɥ쥹Ȥʸɽޥ
; ʸƬɥ쥹ľܻ
;   ex. PRINTSTR esi
%macro  PRINTSTR   1
        pushfd
        pusha
        mov     eax, %1
        call    OutAsciiZ
        call    NewLine
        popa
        popfd
%endmacro

; 쥸ɥ쥹˳Ǽ줿ͤƬɥ쥹Ȥʸ
; ɽޥ
; ʸƬɥ쥹δܻ
;   ex. PRINTSTRI esi
%macro  PRINTSTRI  1
        pushfd
        pusha
        mov     eax, [%1]
        call    OutAsciiZ
        call    NewLine
        popa
        popfd
%endmacro

; ꤷͤɽޥ
; ٤ƤΥ쥸˲ɽǽ
;   ex. CHECK 99
%macro CHECK 1
        pushfd
        push    eax
        mov     eax, %1
        call    PrintLeft
        call    NewLine
        pop     eax
        popfd
%endmacro

; Ԥ
%macro  PAUSE 0
        push    eax
        call    InChar
        pop     eax
%endmacro

%endif
